/*
 *		Shell commands.
 * The file contains the command
 * processor, shell-command
 *	written by Kaoru Maeda.
 */

#include "config.h"	/* 91.01.10  by S.Yoshida */
#include "def.h"

#ifndef NO_SHELL
/*ARGSUSED*/
shellcmnd(f, n)
{
	char	buf[CMDLINELENGTH];
	char	*result;
	extern char *call_process();
	int	s;
	BUFFER	*bp, *obp;
	WINDOW	*wp, *owp;
	WINDOW	*popbuf();

	s = ereply("Shell command: ", buf, sizeof buf);
	if (s != TRUE)
		return s;
	if ((f & FFARG) == 0) {
		if ((bp = bfind("*Shell Command Output*", TRUE)) == NULL) return FALSE;
		if ((wp = popbuf(bp)) == NULL) return FALSE;
		if (bclear(bp) != TRUE) return FALSE;
		obp = curbp; owp = curwp;
		curbp = bp; curwp = wp;
	}
	if ((result = call_process(buf, NULL)) == NULL)
		return FALSE;
	isetmark();
	s = insertfile(result, (char *)NULL);
	if((f & FFARG) == 0) {
		(VOID) gotobob(0, 1);
		bp->b_dotp = wp->w_dotp;
		bp->b_doto = wp->w_doto;
		curbp = obp;
		curwp = owp;
		bp->b_flag &= ~BFCHG;
	}
	unlink(result);
	return s;
}
#endif
